# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from roch_msgs/SensorState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class SensorState(genpy.Message):
  _md5sum = "aab37bd6392c206db3569e25a2b3b375"
  _type = "roch_msgs/SensorState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# roch Sensor Data Messages
#
# For more direct simple interactions (buttons, leds, gyro, motor velocity
# etc) use the other topics. This provides detailed information about the
# entire state package that is transmitted at 50Hz from the robot.
#


###### CONSTANTS ######

# Wheel drop sensor states (states are combined, when both wheel drop sensors are triggered)
uint8 RAISED  = 0
uint8 DROPPED = 1

# Cliff sensor states (states are combined, when multiple cliff sensors are triggered)
uint8 FLOOR = 0
uint8 CLIFF = 1

# Ult/psd sensor states (states are combined, when multiple ult sensors are triggered)
uint8 NORMAL = 0
uint8 NEAR = 1

###### MESSAGE ######

Header header

###################
# Core Packet
###################
uint8  leftwheel_drop      # see wheel drop sensor states
uint8  rightwheel_drop      # see wheel drop sensor states
uint8  leftcliff           # see cliff sensor states
uint8  rightcliff           # see cliff sensor states
uint8  leftult             # see ult sensor states
uint8  centerult             # see ult sensor states
uint8  rightult             # see ult sensor states
uint8  leftpsd             # see psd sensor states
uint8  centerpsd             # see psd sensor states
uint8  rightpsd             # see psd sensor states

###################
# Cliff Packet
###################
float64[] cliffbottom        # ADC output of the right, centre, left cliff PSD sensor (0 - 0.2(meter), distance measure is non-linear)

###################
# Ult Packet
###################
float64[] ultbottom        # ADC output of the right, centre, left Ult sensor (0 - 0.6(meter), distance measure is non-linear)

###################
# PSD Packet
###################
float64[] psdbottom        # ADC output of the right, centre, left PSD sensor (0 - 0.2(meter), distance measure is non-linear)



================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  # Pseudo-constants
  RAISED = 0
  DROPPED = 1
  FLOOR = 0
  CLIFF = 1
  NORMAL = 0
  NEAR = 1

  __slots__ = ['header','leftwheel_drop','rightwheel_drop','leftcliff','rightcliff','leftult','centerult','rightult','leftpsd','centerpsd','rightpsd','cliffbottom','ultbottom','psdbottom']
  _slot_types = ['std_msgs/Header','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','uint8','float64[]','float64[]','float64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,leftwheel_drop,rightwheel_drop,leftcliff,rightcliff,leftult,centerult,rightult,leftpsd,centerpsd,rightpsd,cliffbottom,ultbottom,psdbottom

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.leftwheel_drop is None:
        self.leftwheel_drop = 0
      if self.rightwheel_drop is None:
        self.rightwheel_drop = 0
      if self.leftcliff is None:
        self.leftcliff = 0
      if self.rightcliff is None:
        self.rightcliff = 0
      if self.leftult is None:
        self.leftult = 0
      if self.centerult is None:
        self.centerult = 0
      if self.rightult is None:
        self.rightult = 0
      if self.leftpsd is None:
        self.leftpsd = 0
      if self.centerpsd is None:
        self.centerpsd = 0
      if self.rightpsd is None:
        self.rightpsd = 0
      if self.cliffbottom is None:
        self.cliffbottom = []
      if self.ultbottom is None:
        self.ultbottom = []
      if self.psdbottom is None:
        self.psdbottom = []
    else:
      self.header = std_msgs.msg.Header()
      self.leftwheel_drop = 0
      self.rightwheel_drop = 0
      self.leftcliff = 0
      self.rightcliff = 0
      self.leftult = 0
      self.centerult = 0
      self.rightult = 0
      self.leftpsd = 0
      self.centerpsd = 0
      self.rightpsd = 0
      self.cliffbottom = []
      self.ultbottom = []
      self.psdbottom = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10B().pack(_x.leftwheel_drop, _x.rightwheel_drop, _x.leftcliff, _x.rightcliff, _x.leftult, _x.centerult, _x.rightult, _x.leftpsd, _x.centerpsd, _x.rightpsd))
      length = len(self.cliffbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.cliffbottom))
      length = len(self.ultbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.ultbottom))
      length = len(self.psdbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.psdbottom))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.leftwheel_drop, _x.rightwheel_drop, _x.leftcliff, _x.rightcliff, _x.leftult, _x.centerult, _x.rightult, _x.leftpsd, _x.centerpsd, _x.rightpsd,) = _get_struct_10B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.cliffbottom = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ultbottom = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.psdbottom = struct.unpack(pattern, str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10B().pack(_x.leftwheel_drop, _x.rightwheel_drop, _x.leftcliff, _x.rightcliff, _x.leftult, _x.centerult, _x.rightult, _x.leftpsd, _x.centerpsd, _x.rightpsd))
      length = len(self.cliffbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.cliffbottom.tostring())
      length = len(self.ultbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.ultbottom.tostring())
      length = len(self.psdbottom)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.psdbottom.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.leftwheel_drop, _x.rightwheel_drop, _x.leftcliff, _x.rightcliff, _x.leftult, _x.centerult, _x.rightult, _x.leftpsd, _x.centerpsd, _x.rightpsd,) = _get_struct_10B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.cliffbottom = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.ultbottom = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.psdbottom = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10B = None
def _get_struct_10B():
    global _struct_10B
    if _struct_10B is None:
        _struct_10B = struct.Struct("<10B")
    return _struct_10B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
