// Auto-generated. Do not edit!

// (in-package roch_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class PSDEvent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.leftSensor = null;
      this.leftState = null;
      this.leftBottom = null;
      this.centerSensor = null;
      this.centerState = null;
      this.centerBottom = null;
      this.rightSensor = null;
      this.rightState = null;
      this.rightBottom = null;
    }
    else {
      if (initObj.hasOwnProperty('leftSensor')) {
        this.leftSensor = initObj.leftSensor
      }
      else {
        this.leftSensor = 0;
      }
      if (initObj.hasOwnProperty('leftState')) {
        this.leftState = initObj.leftState
      }
      else {
        this.leftState = 0;
      }
      if (initObj.hasOwnProperty('leftBottom')) {
        this.leftBottom = initObj.leftBottom
      }
      else {
        this.leftBottom = 0.0;
      }
      if (initObj.hasOwnProperty('centerSensor')) {
        this.centerSensor = initObj.centerSensor
      }
      else {
        this.centerSensor = 0;
      }
      if (initObj.hasOwnProperty('centerState')) {
        this.centerState = initObj.centerState
      }
      else {
        this.centerState = 0;
      }
      if (initObj.hasOwnProperty('centerBottom')) {
        this.centerBottom = initObj.centerBottom
      }
      else {
        this.centerBottom = 0.0;
      }
      if (initObj.hasOwnProperty('rightSensor')) {
        this.rightSensor = initObj.rightSensor
      }
      else {
        this.rightSensor = 0;
      }
      if (initObj.hasOwnProperty('rightState')) {
        this.rightState = initObj.rightState
      }
      else {
        this.rightState = 0;
      }
      if (initObj.hasOwnProperty('rightBottom')) {
        this.rightBottom = initObj.rightBottom
      }
      else {
        this.rightBottom = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PSDEvent
    // Serialize message field [leftSensor]
    bufferOffset = _serializer.uint8(obj.leftSensor, buffer, bufferOffset);
    // Serialize message field [leftState]
    bufferOffset = _serializer.uint8(obj.leftState, buffer, bufferOffset);
    // Serialize message field [leftBottom]
    bufferOffset = _serializer.float64(obj.leftBottom, buffer, bufferOffset);
    // Serialize message field [centerSensor]
    bufferOffset = _serializer.uint8(obj.centerSensor, buffer, bufferOffset);
    // Serialize message field [centerState]
    bufferOffset = _serializer.uint8(obj.centerState, buffer, bufferOffset);
    // Serialize message field [centerBottom]
    bufferOffset = _serializer.float64(obj.centerBottom, buffer, bufferOffset);
    // Serialize message field [rightSensor]
    bufferOffset = _serializer.uint8(obj.rightSensor, buffer, bufferOffset);
    // Serialize message field [rightState]
    bufferOffset = _serializer.uint8(obj.rightState, buffer, bufferOffset);
    // Serialize message field [rightBottom]
    bufferOffset = _serializer.float64(obj.rightBottom, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PSDEvent
    let len;
    let data = new PSDEvent(null);
    // Deserialize message field [leftSensor]
    data.leftSensor = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [leftState]
    data.leftState = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [leftBottom]
    data.leftBottom = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [centerSensor]
    data.centerSensor = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [centerState]
    data.centerState = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [centerBottom]
    data.centerBottom = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [rightSensor]
    data.rightSensor = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [rightState]
    data.rightState = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [rightBottom]
    data.rightBottom = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 30;
  }

  static datatype() {
    // Returns string type for a message object
    return 'roch_msgs/PSDEvent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '638b618316102a845053a2e4172b4a5d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Provides a ult sensor event.
    # This message is generated whenever a particular cliff sensor signals that the
    # robot approaches or moves away from a cliff.
    # Note that, despite cliff field on SensorState messages, state field is not a
    # bitmask, but the new state of a single sensor.
    
    # psd sensor
    uint8 LEFT   = 0
    uint8 CENTER = 1
    uint8 RIGHT  = 2
    
    # psd sensor state
    uint8 NORMAL = 0
    uint8 NEAR = 1
    
    uint8 leftSensor
    uint8 leftState
    
    # distance to floor when cliff was detected
    float64 leftBottom
    
    uint8 centerSensor
    uint8 centerState
    
    # distance to floor when cliff was detected
    float64 centerBottom
    
    uint8 rightSensor
    uint8 rightState
    
    # distance to floor when cliff was detected
    float64 rightBottom
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PSDEvent(null);
    if (msg.leftSensor !== undefined) {
      resolved.leftSensor = msg.leftSensor;
    }
    else {
      resolved.leftSensor = 0
    }

    if (msg.leftState !== undefined) {
      resolved.leftState = msg.leftState;
    }
    else {
      resolved.leftState = 0
    }

    if (msg.leftBottom !== undefined) {
      resolved.leftBottom = msg.leftBottom;
    }
    else {
      resolved.leftBottom = 0.0
    }

    if (msg.centerSensor !== undefined) {
      resolved.centerSensor = msg.centerSensor;
    }
    else {
      resolved.centerSensor = 0
    }

    if (msg.centerState !== undefined) {
      resolved.centerState = msg.centerState;
    }
    else {
      resolved.centerState = 0
    }

    if (msg.centerBottom !== undefined) {
      resolved.centerBottom = msg.centerBottom;
    }
    else {
      resolved.centerBottom = 0.0
    }

    if (msg.rightSensor !== undefined) {
      resolved.rightSensor = msg.rightSensor;
    }
    else {
      resolved.rightSensor = 0
    }

    if (msg.rightState !== undefined) {
      resolved.rightState = msg.rightState;
    }
    else {
      resolved.rightState = 0
    }

    if (msg.rightBottom !== undefined) {
      resolved.rightBottom = msg.rightBottom;
    }
    else {
      resolved.rightBottom = 0.0
    }

    return resolved;
    }
};

// Constants for message
PSDEvent.Constants = {
  LEFT: 0,
  CENTER: 1,
  RIGHT: 2,
  NORMAL: 0,
  NEAR: 1,
}

module.exports = PSDEvent;
